import javax.xml.xquery.XQConnection;
import javax.xml.xquery.XQPreparedExpression;
import javax.xml.xquery.XQResultSequence; 
import javax.xml.xquery.XQDataSource;
import javax.xml.xquery.XQItemType;
import javax.xml.xquery.XQResultSequence;
import javax.xml.namespace.QName;
import javax.xml.xquery.XQItemType;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import org.w3c.dom.Element;
import org.w3c.dom.Document;

public class NPEReproducer {
    private final static String XQ_DRIVER 
        = "org.basex.api.xqj.BXQDataSource";
    
    static void reproduceNPE() throws Exception {
        @SuppressWarnings("unchecked")
        XQDataSource xqds 
            = (XQDataSource)Class.forName(XQ_DRIVER).newInstance();
        XQConnection conn = xqds.getConnection();
        String istmt = 
            "declare variable $inserto as element(*,xs:untyped) external;\n"
          + "let $root := basex:db('Annotations')/Annotations\n"
          + "return (insert node $inserto into $root)\n"
        ;
        XQPreparedExpression ixpr = conn.prepareExpression(istmt);
        
        DocumentBuilderFactory fctry = DocumentBuilderFactory.newInstance();
        DocumentBuilder bldr = fctry.newDocumentBuilder();

        Document doc = bldr.newDocument();
        Element inserto  = doc.createElement("inserto");
        inserto.setAttribute("id","11");
        Element testo = doc.createElement("testo");
        testo.setTextContent("undici");
        inserto.appendChild(testo);
        
        XQItemType eltype 
            = conn.createElementType(null, XQItemType.XQBASETYPE_ANYTYPE);
        ixpr.bindNode(new QName("inserto"), inserto, eltype);
        
        XQResultSequence rs = ixpr.executeQuery();
        rs.close();
        
        inserto.setAttribute("id","12");
        testo.setTextContent("dodici");

        ixpr.bindNode(new QName("inserto"), inserto, eltype);
        rs = ixpr.executeQuery();
        rs.close();
        
        ixpr.close();
        conn.close();
    }
    
    public static void main(String [] args) {
        try {
            reproduceNPE();
        }
        catch( Exception ex) {
            ex.printStackTrace();
        }
    }
}